diff --git a/tensorflow/contrib/labeled_tensor/python/ops/core_test.py b/tensorflow/contrib/labeled_tensor/python/ops/core_test.py
index e378db56afb..738c45523a4 100644
--- a/tensorflow/contrib/labeled_tensor/python/ops/core_test.py
+++ b/tensorflow/contrib/labeled_tensor/python/ops/core_test.py
@@ -22,7 +22,6 @@ import re
 import textwrap
 
 import numpy as np
-from six.moves import range  # pylint: disable=redefined-builtin
 
 from tensorflow.contrib.labeled_tensor.python.ops import _typecheck as tc
 from tensorflow.contrib.labeled_tensor.python.ops import core
diff --git a/tensorflow/contrib/labeled_tensor/python/ops/ops_test.py b/tensorflow/contrib/labeled_tensor/python/ops/ops_test.py
index 9a402d888cf..68289bca64b 100644
--- a/tensorflow/contrib/labeled_tensor/python/ops/ops_test.py
+++ b/tensorflow/contrib/labeled_tensor/python/ops/ops_test.py
@@ -18,7 +18,6 @@ from __future__ import division
 from __future__ import print_function
 
 import numpy as np
-from six.moves import range  # pylint: disable=redefined-builtin
 
 from tensorflow.contrib.labeled_tensor.python.ops import core
 from tensorflow.contrib.labeled_tensor.python.ops import ops
diff --git a/tensorflow/contrib/labeled_tensor/python/ops/sugar_test.py b/tensorflow/contrib/labeled_tensor/python/ops/sugar_test.py
index 2797e7d5251..6c71918449f 100644
--- a/tensorflow/contrib/labeled_tensor/python/ops/sugar_test.py
+++ b/tensorflow/contrib/labeled_tensor/python/ops/sugar_test.py
@@ -17,7 +17,6 @@ from __future__ import absolute_import
 from __future__ import division
 from __future__ import print_function
 
-from six.moves import range  # pylint: disable=redefined-builtin
 
 from tensorflow.contrib.labeled_tensor.python.ops import core
 from tensorflow.contrib.labeled_tensor.python.ops import ops
diff --git a/tensorflow/contrib/layers/python/layers/embedding_ops.py b/tensorflow/contrib/layers/python/layers/embedding_ops.py
index 14bbe5f9b30..2fcce32799a 100644
--- a/tensorflow/contrib/layers/python/layers/embedding_ops.py
+++ b/tensorflow/contrib/layers/python/layers/embedding_ops.py
@@ -17,7 +17,6 @@ from __future__ import absolute_import
 from __future__ import division
 from __future__ import print_function
 
-from six.moves import xrange  # pylint: disable=redefined-builtin
 
 from tensorflow.contrib.framework.python.framework import tensor_util as contrib_tensor_util
 from tensorflow.contrib.layers.python.ops import sparse_feature_cross_op
@@ -799,13 +798,13 @@ def _embedding_lookup_with_distributed_aggregation(params,
         # partitions based on a constant number of ids per partition. Optimize
         # if we already know the full shape statically.
         dim_0_size = params[0].get_shape().dims[0]
-        for p in xrange(1, np):
+        for p in range(1, np):
           dim_0_size += params[p].get_shape().dims[0]
         if dim_0_size.value:
           num_total_ids = constant_op.constant(dim_0_size, flat_ids.dtype)
         else:
           dim_0_sizes = []
-          for p in xrange(np):
+          for p in range(np):
             if params[p].get_shape().dims[0].value is not None:
               dim_0_sizes.append(params[p].get_shape().dims[0].value)
             else:
@@ -842,7 +841,7 @@ def _embedding_lookup_with_distributed_aggregation(params,
                                                  p_assignments, np)
       # Do np separate lookups, finding embeddings for plist[p] in params[p]
       partitioned_result = []
-      for p in xrange(np):
+      for p in range(np):
         with ops.colocate_with(params[p]):
           partitioned_result.append(_do_gather(params[p], gather_ids[p]))
 
@@ -850,14 +849,14 @@ def _embedding_lookup_with_distributed_aggregation(params,
       if not ignore_weights:
         # Partition weights according to pindices.
         partitioned_weight = []
-        for p in xrange(np):
+        for p in range(np):
           partitioned_weight.append(array_ops.gather(weights, pindices[p]))
       # Reshape each partition result.
       element_shape = params[0].get_shape()[1:]
       for p in params[1:]:
         element_shape = element_shape.merge_with(p.get_shape()[1:])
       if element_shape.is_fully_defined():
-        for p in xrange(np):
+        for p in range(np):
           with ops.colocate_with(params[p]):
             partitioned_result[p] = array_ops.reshape(
                 partitioned_result[p],
@@ -866,7 +865,7 @@ def _embedding_lookup_with_distributed_aggregation(params,
       else:
         with ops.colocate_with(params[0]):
           params_shape = array_ops.shape(params[0])
-        for p in xrange(np):
+        for p in range(np):
           with ops.colocate_with(params[p]):
             partitioned_result[p] = array_ops.reshape(
                 partitioned_result[p],
@@ -875,12 +874,12 @@ def _embedding_lookup_with_distributed_aggregation(params,
                     array_ops.slice(params_shape, [1], [-1])
                 ], 0))
       # Normalize each partition result.
-      for p in xrange(np):
+      for p in range(np):
         with ops.colocate_with(params[p]):
           partitioned_result[p] = maybe_normalize(partitioned_result[p])
       if not ignore_weights:
         # Multiply each partition result with partition weights.
-        for p in xrange(np):
+        for p in range(np):
           with ops.colocate_with(params[p]):
             if partitioned_weight[p].dtype != partitioned_result[p].dtype:
               partitioned_weight[p] = math_ops.cast(partitioned_weight[p],
@@ -902,7 +901,7 @@ def _embedding_lookup_with_distributed_aggregation(params,
                   ]))
             partitioned_result[p] *= partitioned_weight[p]
       partitioned_segment_ids = []
-      for p in xrange(np):
+      for p in range(np):
         if not ignore_weights:
           # Partition segment_ids according to pindices.
           p_segment_ids = array_ops.gather(segment_ids, pindices[p])
diff --git a/tensorflow/contrib/layers/python/layers/rev_block_lib.py b/tensorflow/contrib/layers/python/layers/rev_block_lib.py
index 06da32072f3..e16a1380c4b 100644
--- a/tensorflow/contrib/layers/python/layers/rev_block_lib.py
+++ b/tensorflow/contrib/layers/python/layers/rev_block_lib.py
@@ -31,7 +31,6 @@ import re
 
 import numpy as np
 import six
-from six.moves import xrange  # pylint: disable=redefined-builtin
 
 from tensorflow.contrib.framework.python import ops as contrib_framework_ops
 from tensorflow.python.eager import backprop
@@ -145,7 +144,7 @@ def _rev_block_forward(x1,
                        gate_outputs=False):
   """Forward for a series of reversible layers."""
   out = (x1, x2)
-  for i in xrange(num_layers):
+  for i in range(num_layers):
     out = _rev_layer_forward(
         out, f[i], g[i], f_side_input, g_side_input, gate_outputs=gate_outputs)
 
@@ -294,7 +293,7 @@ class RevBlock(base.Layer):
       g.reverse()
 
       with variable_scope.variable_scope(self.scope_name, reuse=True):
-        for i in xrange(self.num_layers):
+        for i in range(self.num_layers):
           ys, grad_ys, f_ret, g_ret = _rev_layer_backward(
               ys, grad_ys, f[i], g[i], f_vars[i], self.f_side_input, g_vars[i],
               self.g_side_input)
@@ -369,7 +368,7 @@ class RevBlock(base.Layer):
     f.reverse()
     g.reverse()
 
-    for i in xrange(self.num_layers):
+    for i in range(self.num_layers):
       gy1 = g[i](y1, self.g_side_input) if self.g_side_input else g[i](y1)
       x2 = y2 - gy1
       fx2 = f[i](x2, self.f_side_input) if self.f_side_input else f[i](x2)
diff --git a/tensorflow/contrib/learn/python/learn/datasets/mnist.py b/tensorflow/contrib/learn/python/learn/datasets/mnist.py
index abbb44c2f5b..d30e81f8ba5 100644
--- a/tensorflow/contrib/learn/python/learn/datasets/mnist.py
+++ b/tensorflow/contrib/learn/python/learn/datasets/mnist.py
@@ -26,7 +26,6 @@ from __future__ import print_function
 import gzip
 
 import numpy
-from six.moves import xrange  # pylint: disable=redefined-builtin
 
 from tensorflow.contrib.learn.python.learn.datasets import base
 from tensorflow.python.framework import dtypes
@@ -188,8 +187,8 @@ class DataSet(object):
         fake_label = [1] + [0] * 9
       else:
         fake_label = 0
-      return [fake_image for _ in xrange(batch_size)], [
-          fake_label for _ in xrange(batch_size)
+      return [fake_image for _ in range(batch_size)], [
+          fake_label for _ in range(batch_size)
       ]
     start = self._index_in_epoch
     # Shuffle for the first epoch
diff --git a/tensorflow/contrib/learn/python/learn/estimators/estimator_test.py b/tensorflow/contrib/learn/python/learn/estimators/estimator_test.py
index 153d4867961..85e1807c117 100644
--- a/tensorflow/contrib/learn/python/learn/estimators/estimator_test.py
+++ b/tensorflow/contrib/learn/python/learn/estimators/estimator_test.py
@@ -26,7 +26,6 @@ import tempfile
 
 import numpy as np
 import six
-from six.moves import xrange  # pylint: disable=redefined-builtin
 
 from google.protobuf import text_format
 
@@ -1284,7 +1283,7 @@ class InferRealValuedColumnsTest(test.TestCase):
     with self.assertRaisesRegexp(
         ValueError, 'on integer or non floating types are not supported'):
       estimator.infer_real_valued_columns_from_input(
-          np.array([[False for _ in xrange(8)] for _ in xrange(7)]))
+          np.array([[False for _ in range(8)] for _ in range(7)]))
 
   def testBoolInputFn(self):
     with self.assertRaisesRegexp(
@@ -1299,7 +1298,7 @@ class InferRealValuedColumnsTest(test.TestCase):
         ValueError, 'on integer or non floating types are not supported'):
       # pylint: disable=g-long-lambda
       estimator.infer_real_valued_columns_from_input(
-          np.array([['%d.0' % i for i in xrange(8)] for _ in xrange(7)]))
+          np.array([['%d.0' % i for i in range(8)] for _ in range(7)]))
 
   def testStringInputFn(self):
     with self.assertRaisesRegexp(
@@ -1308,8 +1307,8 @@ class InferRealValuedColumnsTest(test.TestCase):
       estimator.infer_real_valued_columns_from_input_fn(
           lambda: (
               constant_op.constant([['%d.0' % i
-                                     for i in xrange(8)]
-                                    for _ in xrange(7)]),
+                                     for i in range(8)]
+                                    for _ in range(7)]),
               None))
 
   def testBostonInputFn(self):
diff --git a/tensorflow/contrib/learn/python/learn/learn_io/data_feeder.py b/tensorflow/contrib/learn/python/learn/learn_io/data_feeder.py
index b7dba0f2775..901ce6062e0 100644
--- a/tensorflow/contrib/learn/python/learn/learn_io/data_feeder.py
+++ b/tensorflow/contrib/learn/python/learn/learn_io/data_feeder.py
@@ -30,7 +30,6 @@ import math
 
 import numpy as np
 import six
-from six.moves import xrange  # pylint: disable=redefined-builtin
 
 from tensorflow.python.framework import dtypes
 from tensorflow.python.framework import tensor_util
@@ -223,7 +222,7 @@ def setup_predict_data_feeder(x, batch_size=None):
     if batch_size <= 0:
       raise ValueError('Invalid batch_size %d.' % batch_size)
     n_batches = int(math.ceil(float(len(x)) / batch_size))
-    return [x[i * batch_size:(i + 1) * batch_size] for i in xrange(n_batches)]
+    return [x[i * batch_size:(i + 1) * batch_size] for i in range(n_batches)]
   return [x]
 
 
@@ -502,7 +501,7 @@ class DataFeeder(object):
     def assign_label(data, shape, dtype, n_classes, indices):
       shape[0] = indices.shape[0]
       out = np.zeros(shape, dtype=dtype)
-      for i in xrange(out.shape[0]):
+      for i in range(out.shape[0]):
         sample = indices[i]
         # self.n_classes is None means we're passing in raw target indices
         if n_classes is None:
@@ -752,7 +751,7 @@ class StreamingDataFeeder(DataFeeder):
       inp = init_array(self.input_shape, self._input_dtype)
       out = init_array(self.output_shape, self._output_dtype)
 
-      for i in xrange(self._batch_size):
+      for i in range(self._batch_size):
         # Add handling when queue ends.
         try:
           next_inp = six.next(self._x)
diff --git a/tensorflow/contrib/learn/python/learn/learn_io/data_feeder_test.py b/tensorflow/contrib/learn/python/learn/learn_io/data_feeder_test.py
index 284a4f45f63..9098550a630 100644
--- a/tensorflow/contrib/learn/python/learn/learn_io/data_feeder_test.py
+++ b/tensorflow/contrib/learn/python/learn/learn_io/data_feeder_test.py
@@ -21,7 +21,6 @@ from __future__ import print_function
 import os.path
 import numpy as np
 import six
-from six.moves import xrange  # pylint: disable=redefined-builtin
 
 # pylint: disable=wildcard-import
 from tensorflow.contrib.learn.python.learn.learn_io import *
@@ -122,12 +121,12 @@ class DataFeederTest(test.TestCase):
     self._assert_dtype(np.float64, dtypes.float64, self._wrap_dict(data))
 
   def test_input_bool(self):
-    data = np.array([[False for _ in xrange(2)] for _ in xrange(2)])
+    data = np.array([[False for _ in range(2)] for _ in range(2)])
     self._assert_dtype(np.bool, dtypes.bool, data)
     self._assert_dtype(np.bool, dtypes.bool, self._wrap_dict(data))
 
   def test_input_string(self):
-    input_data = np.array([['str%d' % i for i in xrange(2)] for _ in xrange(2)])
+    input_data = np.array([['str%d' % i for i in range(2)] for _ in range(2)])
     self._assert_dtype(input_data.dtype, dtypes.string, input_data)
     self._assert_dtype(input_data.dtype, dtypes.string,
                        self._wrap_dict(input_data))
diff --git a/tensorflow/contrib/learn/python/learn/learn_io/graph_io_test.py b/tensorflow/contrib/learn/python/learn/learn_io/graph_io_test.py
index 8e68a17e478..be026dcfeec 100644
--- a/tensorflow/contrib/learn/python/learn/learn_io/graph_io_test.py
+++ b/tensorflow/contrib/learn/python/learn/learn_io/graph_io_test.py
@@ -23,7 +23,6 @@ import os
 import random
 import tempfile
 
-from six.moves import xrange  # pylint: disable=redefined-builtin
 
 from tensorflow.contrib.learn.python.learn.learn_io import graph_io
 from tensorflow.python.client import session as session_lib
@@ -365,7 +364,7 @@ class GraphIOTest(test.TestCase):
     num_records = 49999
     lines = [
         "".join([sequence_prefix, str(l)]).encode("ascii")
-        for l in xrange(num_records)
+        for l in range(num_records)
     ]
     filename = self._create_file_from_list_of_features(lines)
     batch_size = 10000
@@ -421,7 +420,7 @@ class GraphIOTest(test.TestCase):
     """
     gfile.Glob = self._orig_glob
     num_records = 1000
-    lines = ["".join(str(l)).encode("ascii") for l in xrange(num_records)]
+    lines = ["".join(str(l)).encode("ascii") for l in range(num_records)]
     filename = self._create_file_from_list_of_features(lines)
     batch_size = 10
     queue_capacity = 1000
diff --git a/tensorflow/contrib/learn/python/learn/monitors_test.py b/tensorflow/contrib/learn/python/learn/monitors_test.py
index d4a7169bb63..b0abc8f3a1d 100644
--- a/tensorflow/contrib/learn/python/learn/monitors_test.py
+++ b/tensorflow/contrib/learn/python/learn/monitors_test.py
@@ -23,7 +23,6 @@ import shutil
 import tempfile
 import time
 
-from six.moves import xrange  # pylint: disable=redefined-builtin
 
 from tensorflow.contrib import testing
 from tensorflow.contrib.framework.python.framework import checkpoint_utils
@@ -109,7 +108,7 @@ class MonitorsTest(test.TestCase):
     else:
       max_steps = None
     monitor.begin(max_steps=max_steps)
-    for epoch in xrange(num_epochs):
+    for epoch in range(num_epochs):
       monitor.epoch_begin(epoch)
       should_stop = False
       step = epoch * num_steps_per_epoch
@@ -538,7 +537,7 @@ class MonitorsTest(test.TestCase):
               counter_var.name: step + 1.0,
               assign_add.name: step + 1.0,
           }
-          for step in xrange(30)
+          for step in range(30)
       }, monitor0.data)
 
       self._run_monitor(monitor1, num_epochs=3, num_steps_per_epoch=10)
@@ -548,10 +547,10 @@ class MonitorsTest(test.TestCase):
               counter_var.name: step + 31.0,
               assign_add.name: step + 31.0,
           }
-          for step in xrange(30)
+          for step in range(30)
       }, monitor1.data)
 
-      for step in xrange(30):
+      for step in range(30):
         matched, non_matched = monitor1.compare(monitor0, step=step)
         self.assertEqual([const_var.name], matched)
         self.assertEqual({
diff --git a/tensorflow/contrib/learn/python/learn/utils/gc.py b/tensorflow/contrib/learn/python/learn/utils/gc.py
index f69a4dd6ad5..74109a757e9 100644
--- a/tensorflow/contrib/learn/python/learn/utils/gc.py
+++ b/tensorflow/contrib/learn/python/learn/utils/gc.py
@@ -37,7 +37,7 @@ Note that functions should always return a sorted list.
 For example,
   base_dir = "/tmp"
   # Create the directories.
-  for e in xrange(10):
+  for e in range(10):
     os.mkdir("%s/%d" % (base_dir, e), 0o755)
 
   # Create a simple parser that pulls the export_version from the directory.
diff --git a/tensorflow/contrib/learn/python/learn/utils/gc_test.py b/tensorflow/contrib/learn/python/learn/utils/gc_test.py
index af93e517f51..2de8d73d599 100644
--- a/tensorflow/contrib/learn/python/learn/utils/gc_test.py
+++ b/tensorflow/contrib/learn/python/learn/utils/gc_test.py
@@ -21,7 +21,6 @@ from __future__ import print_function
 import os
 import re
 
-from six.moves import xrange  # pylint: disable=redefined-builtin
 
 from tensorflow.contrib.learn.python.learn.utils import gc
 from tensorflow.python.framework import test_util
@@ -103,7 +102,7 @@ class GcTest(test_util.TensorFlowTestCase):
 
   def testUnion(self):
     paths = []
-    for i in xrange(10):
+    for i in range(10):
       paths.append(gc.Path("/foo", i))
     f = gc.union(gc.largest_export_versions(3), gc.mod_export_version(3))
     self.assertEqual(
@@ -131,7 +130,7 @@ class GcTest(test_util.TensorFlowTestCase):
   def testPathsWithParse(self):
     base_dir = os.path.join(test.get_temp_dir(), "paths_parse")
     self.assertFalse(gfile.Exists(base_dir))
-    for p in xrange(3):
+    for p in range(3):
       gfile.MakeDirs(os.path.join(base_dir, "%d" % p))
     # add a base_directory to ignore
     gfile.MakeDirs(os.path.join(base_dir, "ignore"))
diff --git a/tensorflow/contrib/legacy_seq2seq/python/ops/seq2seq.py b/tensorflow/contrib/legacy_seq2seq/python/ops/seq2seq.py
index 9555bb2fe8b..bbc3ab74fe3 100644
--- a/tensorflow/contrib/legacy_seq2seq/python/ops/seq2seq.py
+++ b/tensorflow/contrib/legacy_seq2seq/python/ops/seq2seq.py
@@ -59,8 +59,6 @@ from __future__ import print_function
 import copy
 
 # We disable pylint because we need python3 compatibility.
-from six.moves import xrange  # pylint: disable=redefined-builtin
-from six.moves import zip  # pylint: disable=redefined-builtin
 
 from tensorflow.contrib.rnn.python.ops import core_rnn_cell
 from tensorflow.python.framework import dtypes
@@ -622,7 +620,7 @@ def attention_decoder(decoder_inputs,
     hidden_features = []
     v = []
     attention_vec_size = attn_size  # Size of query vectors for attention.
-    for a in xrange(num_heads):
+    for a in range(num_heads):
       k = variable_scope.get_variable(
           "AttnW_%d" % a, [1, 1, attn_size, attention_vec_size], dtype=dtype)
       hidden_features.append(nn_ops.conv2d(hidden, k, [1, 1, 1, 1], "SAME"))
@@ -642,7 +640,7 @@ def attention_decoder(decoder_inputs,
           if ndims:
             assert ndims == 2
         query = array_ops.concat(query_list, 1)
-      for a in xrange(num_heads):
+      for a in range(num_heads):
         with variable_scope.variable_scope("Attention_%d" % a):
           y = Linear(query, attention_vec_size, True)(query)
           y = array_ops.reshape(y, [-1, 1, 1, attention_vec_size])
@@ -662,7 +660,7 @@ def attention_decoder(decoder_inputs,
     prev = None
     batch_attn_size = array_ops.stack([batch_size, attn_size])
     attns = [
-        array_ops.zeros(batch_attn_size, dtype=dtype) for _ in xrange(num_heads)
+        array_ops.zeros(batch_attn_size, dtype=dtype) for _ in range(num_heads)
     ]
     for a in attns:  # Ensure the second shape of attention vectors is set.
       a.set_shape([None, attn_size])
diff --git a/tensorflow/contrib/linear_optimizer/python/ops/sdca_ops.py b/tensorflow/contrib/linear_optimizer/python/ops/sdca_ops.py
index 950840c6b77..6b6d932752a 100644
--- a/tensorflow/contrib/linear_optimizer/python/ops/sdca_ops.py
+++ b/tensorflow/contrib/linear_optimizer/python/ops/sdca_ops.py
@@ -26,8 +26,6 @@ from __future__ import print_function
 
 import collections
 
-from six.moves import range
-
 from tensorflow.contrib.linear_optimizer.python.ops.sharded_mutable_dense_hashtable import ShardedMutableDenseHashTable
 from tensorflow.python.compat import compat
 from tensorflow.python.framework import constant_op
diff --git a/tensorflow/contrib/linear_optimizer/python/ops/sharded_mutable_dense_hashtable.py b/tensorflow/contrib/linear_optimizer/python/ops/sharded_mutable_dense_hashtable.py
index 8fda828e994..796dec348be 100644
--- a/tensorflow/contrib/linear_optimizer/python/ops/sharded_mutable_dense_hashtable.py
+++ b/tensorflow/contrib/linear_optimizer/python/ops/sharded_mutable_dense_hashtable.py
@@ -23,8 +23,6 @@ from __future__ import absolute_import
 from __future__ import division
 from __future__ import print_function
 
-from six.moves import range
-
 from tensorflow.contrib import lookup
 from tensorflow.python.framework import dtypes
 from tensorflow.python.framework import ops
diff --git a/tensorflow/contrib/metrics/python/ops/metric_ops_large_test.py b/tensorflow/contrib/metrics/python/ops/metric_ops_large_test.py
index 5777e64c294..0a16710bf4e 100644
--- a/tensorflow/contrib/metrics/python/ops/metric_ops_large_test.py
+++ b/tensorflow/contrib/metrics/python/ops/metric_ops_large_test.py
@@ -19,7 +19,6 @@ from __future__ import division
 from __future__ import print_function
 
 import numpy as np
-from six.moves import xrange  # pylint: disable=redefined-builtin
 from tensorflow.contrib.metrics.python.ops import metric_ops
 from tensorflow.python.framework import dtypes as dtypes_lib
 from tensorflow.python.framework import ops
@@ -49,7 +48,7 @@ class StreamingPrecisionRecallAtEqualThresholdsLargeTest(test.TestCase):
 
     with self.cached_session() as sess:
       sess.run(variables.local_variables_initializer())
-      for _ in xrange(num_updates):
+      for _ in range(num_updates):
         sess.run(update_op)
 
       prdata = sess.run(result)
diff --git a/tensorflow/contrib/metrics/python/ops/metric_ops_test.py b/tensorflow/contrib/metrics/python/ops/metric_ops_test.py
index 906bebe3b82..b7ca4539de9 100644
--- a/tensorflow/contrib/metrics/python/ops/metric_ops_test.py
+++ b/tensorflow/contrib/metrics/python/ops/metric_ops_test.py
@@ -21,7 +21,6 @@ from __future__ import print_function
 import math
 
 import numpy as np
-from six.moves import xrange  # pylint: disable=redefined-builtin
 from tensorflow.contrib import metrics as metrics_lib
 from tensorflow.contrib.metrics.python.ops import metric_ops
 from tensorflow.python.framework import constant_op
@@ -562,7 +561,7 @@ class StreamingAccuracyTest(test.TestCase):
       accuracy, update_op = metrics.streaming_accuracy(predictions, labels)
 
       sess.run(variables.local_variables_initializer())
-      for _ in xrange(3):
+      for _ in range(3):
         sess.run(update_op)
       self.assertEqual(0.5, sess.run(update_op))
       self.assertEqual(0.5, accuracy.eval())
@@ -649,7 +648,7 @@ class StreamingAccuracyTest(test.TestCase):
                                                        weights)
 
       sess.run(variables.local_variables_initializer())
-      for _ in xrange(3):
+      for _ in range(3):
         sess.run(update_op)
       self.assertEqual(1.0, sess.run(update_op))
       self.assertEqual(1.0, accuracy.eval())
@@ -1971,11 +1970,11 @@ class StreamingDynamicAUCTest(test.TestCase):
     with self.cached_session() as sess:
       sess.run(variables.local_variables_initializer())
       # Run several updates.
-      for _ in xrange(10):
+      for _ in range(10):
         sess.run(update_op)
       # Then verify idempotency.
       initial_auc = auc.eval()
-      for _ in xrange(10):
+      for _ in range(10):
         self.assertAlmostEqual(initial_auc, auc.eval(), 5)
 
   def testAllLabelsOnes(self):
@@ -2082,7 +2081,7 @@ class StreamingDynamicAUCTest(test.TestCase):
     auc, update_op = metrics.streaming_dynamic_auc(tf_labels, tf_predictions)
     with self.cached_session() as sess:
       sess.run(variables.local_variables_initializer())
-      for _ in xrange(num_batches):
+      for _ in range(num_batches):
         new_labels = np.random.randint(0, 2, size=batch_size)
         noise = np.random.normal(0.0, scale=0.2, size=batch_size)
         new_predictions = 0.4 + 0.2 * new_labels + noise
@@ -2152,7 +2151,7 @@ class StreamingDynamicAUCTest(test.TestCase):
                                                    weights=tf_weights)
     with self.cached_session() as sess:
       sess.run(variables.local_variables_initializer())
-      for _ in xrange(num_batches):
+      for _ in range(num_batches):
         new_labels = np.random.randint(0, 2, size=batch_size)
         noise = np.random.uniform(-0.2, 0.2, size=batch_size)
         new_predictions = 0.4 + 0.2 * new_labels + noise
@@ -2325,7 +2324,7 @@ class AucWithConfidenceIntervalsTest(test.TestCase):
                                                            tf_predictions)
     with self.cached_session() as sess:
       sess.run(variables.local_variables_initializer())
-      for _ in xrange(num_batches):
+      for _ in range(num_batches):
         new_labels = np.random.randint(0, 2, size=batch_size)
         noise = np.random.normal(0.0, scale=0.2, size=batch_size)
         new_predictions = 0.4 + 0.2 * new_labels + noise
@@ -4161,7 +4160,7 @@ class StreamingSparsePrecisionTest(test.TestCase):
     precision_ex1 = (0.0 / 1, 1.0 / 2, 1.0 / 3, 2.0 / 4)
     avg_precision_ex1 = (0.0 / 1, precision_ex1[1] / 2, precision_ex1[1] / 3,
                          (precision_ex1[1] + precision_ex1[3]) / 4)
-    for i in xrange(4):
+    for i in range(4):
       k = i + 1
       self._test_streaming_sparse_precision_at_k(
           predictions, labels, k, expected=precision_ex1[i])
@@ -4181,7 +4180,7 @@ class StreamingSparsePrecisionTest(test.TestCase):
     precision_ex2 = (0.0 / 1, 0.0 / 2, 1.0 / 3, 2.0 / 4)
     avg_precision_ex2 = (0.0 / 1, 0.0 / 2, precision_ex2[2] / 3,
                          (precision_ex2[2] + precision_ex2[3]) / 4)
-    for i in xrange(4):
+    for i in range(4):
       k = i + 1
       self._test_streaming_sparse_precision_at_k(
           predictions, labels, k, expected=precision_ex2[i])
@@ -4203,7 +4202,7 @@ class StreamingSparsePrecisionTest(test.TestCase):
         (ex1 + ex2) / 2
         for ex1, ex2 in zip(avg_precision_ex1, avg_precision_ex2)
     ]
-    for i in xrange(4):
+    for i in range(4):
       k = i + 1
       self._test_streaming_sparse_precision_at_k(
           predictions, labels, k, expected=streaming_precision[i])
@@ -4222,7 +4221,7 @@ class StreamingSparsePrecisionTest(test.TestCase):
         (weights[0] * ex1 + weights[1] * ex2) / (weights[0] + weights[1])
         for ex1, ex2 in zip(avg_precision_ex1, avg_precision_ex2)
     ]
-    for i in xrange(4):
+    for i in range(4):
       k = i + 1
       self._test_streaming_sparse_average_precision_at_k(
           predictions,
@@ -4246,7 +4245,7 @@ class StreamingSparsePrecisionTest(test.TestCase):
     precision_ex1 = (0.0 / 1, 1.0 / 2, 1.0 / 3, 2.0 / 4)
     avg_precision_ex1 = (0.0 / 1, precision_ex1[1] / 2, precision_ex1[1] / 3,
                          (precision_ex1[1] + precision_ex1[3]) / 4)
-    for i in xrange(4):
+    for i in range(4):
       k = i + 1
       self._test_streaming_sparse_precision_at_k(
           predictions, labels, k, expected=precision_ex1[i])
@@ -4526,7 +4525,7 @@ class StreamingSparsePrecisionTest(test.TestCase):
         [[[0, 0, 1, 0, 0, 0, 0, 1, 1, 0], [0, 1, 1, 0, 0, 1, 0, 0, 0, 0]],
          [[0, 1, 1, 0, 0, 1, 0, 1, 0, 0], [0, 0, 1, 0, 0, 0, 0, 0, 1, 0]]])
 
-    for class_id in xrange(10):
+    for class_id in range(10):
       self._test_streaming_sparse_precision_at_k(
           predictions,
           labels,
@@ -5231,7 +5230,7 @@ class StreamingSparseRecallTest(test.TestCase):
         [[[0, 0, 1, 0, 0, 0, 0, 1, 1, 0], [0, 1, 1, 0, 0, 1, 0, 0, 0, 0]],
          [[0, 1, 1, 0, 0, 1, 0, 1, 0, 0], [0, 0, 1, 0, 0, 0, 0, 0, 1, 0]]])
 
-    for class_id in xrange(10):
+    for class_id in range(10):
       self._test_streaming_sparse_recall_at_k(
           predictions,
           labels,
diff --git a/tensorflow/contrib/model_pruning/examples/cifar10/cifar10_input.py b/tensorflow/contrib/model_pruning/examples/cifar10/cifar10_input.py
index 6a3b535eb44..4cb59dbfc10 100644
--- a/tensorflow/contrib/model_pruning/examples/cifar10/cifar10_input.py
+++ b/tensorflow/contrib/model_pruning/examples/cifar10/cifar10_input.py
@@ -20,7 +20,6 @@ from __future__ import print_function
 
 import os
 
-from six.moves import xrange  # pylint: disable=redefined-builtin
 import tensorflow as tf
 
 # Process images of this size. Note that this differs from the original CIFAR
@@ -149,7 +148,7 @@ def distorted_inputs(data_dir, batch_size):
     labels: Labels. 1D tensor of [batch_size] size.
   """
   filenames = [
-      os.path.join(data_dir, 'data_batch_%d.bin' % i) for i in xrange(1, 6)
+      os.path.join(data_dir, 'data_batch_%d.bin' % i) for i in range(1, 6)
   ]
   for f in filenames:
     if not tf.gfile.Exists(f):
@@ -217,7 +216,7 @@ def inputs(eval_data, data_dir, batch_size):
   """
   if not eval_data:
     filenames = [
-        os.path.join(data_dir, 'data_batch_%d.bin' % i) for i in xrange(1, 6)
+        os.path.join(data_dir, 'data_batch_%d.bin' % i) for i in range(1, 6)
     ]
     num_examples_per_epoch = NUM_EXAMPLES_PER_EPOCH_FOR_TRAIN
   else:
diff --git a/tensorflow/contrib/optimizer_v2/momentum_test.py b/tensorflow/contrib/optimizer_v2/momentum_test.py
index e69f12839e9..c1a9ee4ba16 100644
--- a/tensorflow/contrib/optimizer_v2/momentum_test.py
+++ b/tensorflow/contrib/optimizer_v2/momentum_test.py
@@ -19,7 +19,6 @@ from __future__ import division
 from __future__ import print_function
 
 import numpy as np
-from six.moves import xrange  # pylint: disable=redefined-builtin
 
 from tensorflow.contrib.optimizer_v2 import momentum as momentum_lib
 from tensorflow.python.eager import context
@@ -443,7 +442,7 @@ class MomentumOptimizerTest(test.TestCase):
       mom_opt = momentum_lib.MomentumOptimizer(learning_rate=0.1, momentum=0.1)
       mom_update = mom_opt.apply_gradients(zip([grads0], [var0]))
       variables.global_variables_initializer().run()
-      for i in xrange(num_samples):
+      for i in range(num_samples):
         mom_update.run(feed_dict={grads0: db_grad[i]})
         self.assertAllClose(np.array(db_out[i]), var0.eval())
 
diff --git a/tensorflow/contrib/recurrent/python/kernel_tests/recurrent_test.py b/tensorflow/contrib/recurrent/python/kernel_tests/recurrent_test.py
index aea80a5256e..a945c414722 100644
--- a/tensorflow/contrib/recurrent/python/kernel_tests/recurrent_test.py
+++ b/tensorflow/contrib/recurrent/python/kernel_tests/recurrent_test.py
@@ -20,7 +20,6 @@ from __future__ import print_function
 
 import collections
 
-from six.moves import xrange  # pylint: disable=redefined-builtin
 
 from tensorflow.contrib.recurrent.python.ops import recurrent
 from tensorflow.python.framework import dtypes
@@ -155,7 +154,7 @@ class RecurrentTest(test_util.TensorFlowTestCase):
       # Statically unrolled.
       s = state0
       out = []
-      for i in xrange(seqlen):
+      for i in range(seqlen):
         inp = _ElmanInputs(x=inputs.x[i, :])
         s, _ = RecurrentTest.Elman(theta, s, inp)
         out += [s.h]
